/*****************************************************************************
CSmartTETask

	Implements undo for cut, copy, paste, clear, and typing commands.
	Undo is implemented simply by saving off the entire text handle of
	the TEHandle. This is fine for small pieces of text, as in dialogs,
	but for larger pieces of text, a more economical method would be preferred.

	by Dan Podwall - you may do anything you please with this code except
	charge for it, with the exception of normal network download charges.

SUPERCLASS = CTask
*****************************************************************************/

#define _H_CSmartTETask

#include "CTask.h"
#include "CSmartEditText.h"

struct CSmartTETask : CTask
{
	struct CSmartEditText *itsEditText;
	tTE_Command		itsCommand;
	Handle			undoText;
	Int16			startSel, endSel;
	Boolean			wasDirty;
	
	virtual void ISmartTETask( struct CSmartEditText *theEditText, Int16 firstNameIndex,
						tTE_Command theCommand);
						
	virtual void Undo( void);
	
	virtual void Dispose( void);

};